#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: do_create.cgi,v 1.1.1.1 2001/12/11 06:50:39 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.  Use Time::HiRes for the timer.
  use Time::HiRes qw(usleep ualarm gettimeofday tv_interval);
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($b, %backups, $create_cmd, $exclude_file, $rc, $level);
  my ($t0, $t1, $timespent);

  ###  Setup local variables.
  $b           =  $in{'selectedBackup'};
  %backups     =  &ListNamedBackups();

  $create_cmd  =  "$FLEXBACKUP_BIN -fs $backups{$b}->{'directory'}";


  ###  Throw an error if our target directory does not exist.
  if (! -d $backups{$b}->{'directory'}) {
    &PrintError("Unable to backup '$backups{$b}->{'directory'} because it does n
ot exist.");
    exit;
  }


  ###
  ###  If we have an exclude list, we need to write the exclude patterns to a
  ###  temp file which we then pass to flexbackup as -exclude <file>.  Remove
  ###  the file when we're all done.
  ###
  if ($backups{$b}->{'exclude'}) {
    $exclude_file  =  &tempname();

    open EXCLUDEFILE, ">$exclude_file";
      foreach my $l (split /\ /, $backups{$b}->{'exclude'}) {
        print EXCLUDEFILE "$l\n";
      }
    close EXCLUDEFILE;

    $create_cmd .=  " -exclude $exclude_file";
  }


  ###  Do we want an incremental backup?
  if ($in{'incremental'}) {
    $create_cmd .=  " -level 9";
    $level       =  9;
  }
  else {
    $level       =  0;
  }

  ###  We now have our command string built up, so let's execute it.
  $create_cmd .=  " >/dev/null 2>&1";
  $t0  =  [gettimeofday];
    system($create_cmd);
    $rc  =  $?;
  $t1  =  [gettimeofday];
  $timespent  =  tv_interval $t0, $t1;

  ###  Remove our temp file.
  unlink $exclude_file;


  ###  Go to the stats page.
  &redirect("stats_create.cgi?selectedBackup=$b&rc=$rc&time=$timespent&level=$level");
