#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: do_diff.cgi,v 1.1.1.1 2001/12/11 06:50:39 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.  Use Time::HiRes for the timer.
  use Time::HiRes qw(usleep ualarm gettimeofday tv_interval);
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($b, $level, $date, %BACKUPS, @backups, $stored_backup, $tempfile);
  my ($seek_cmd, $diff_cmd);
  my ($t0, $t1, $timespent);

  ###  Setup local variables.
  $tempfile        =  &tempname();
  $b               =  $in{'selectedBackup'};
  ($date, $level)  =  split /\|/, $in{'diffInfo'};
  %BACKUPS         =  &ListNamedBackups();
  @backups         =  &ListStoredBackups($b);


  ###  Iterate through all the backups for this $b and find our target file.
  foreach my $x (@backups) {
    if ( ($x->{'level'} eq $level) && ($x->{'date'} eq $date) ) {
      $stored_backup = $x;
    }
  }


  ###  Build up our command based upon the storage medium.
  if ($stored_backup->{'file'} eq "TAPE") {
    $seek_cmd  =  "mt -f /dev/nst0 seek ";
    $seek_cmd .=  &GetStartBlock($stored_backup->{'base'},
                                 $stored_backup->{'datestamp'}, $level);
    $seek_cmd .=  " > /dev/null 2>&1";

    $diff_cmd  =  "$FLEXBACKUP_BIN -compare";
  }
  else {
    $seek_cmd  =  undef;

    $diff_cmd  =  "$FLEXBACKUP_BIN -compare $stored_backup->{'file'}";
  }


  ###
  ###  Change directory to the directory we want to restore.
  ###
  chdir $BACKUPS{$b}->{'directory'};


  ###  We now have our command strings built up, so let's execute it.
  $diff_cmd .=  " > $tempfile 2>&1";
  $t0  =  [gettimeofday];
    system($seek_cmd) if ($seek_cmd);
    system($diff_cmd);
    $rc  =  $?;
  $t1  =  [gettimeofday];
  $timespent  =  tv_interval $t0, $t1;


  ###  Redirect to our stats page.
  &redirect("stats_diff.cgi?selectedBackup=$b&rc=$rc&time=$timespent&level=$level&date=$date&readfile=$tempfile");

