#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: do_edit_named_backup.cgi,v 1.1.1.1.4.2 2003/04/18 12:37:08 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###
  ###  BEGIN Input Validation
  ###
    if (! $in{'name'}) {
      &PrintError("Please enter a 'Backup Description'"); exit; 
    }
    elsif (! $in{'directory'}) {
      &PrintError("Please enter a 'Directory'"); exit; 
    }
    elsif (! $in{'schedule'}) {
      &PrintError("Please select a 'Backup Schedule'"); exit; 
    }
    elsif (! defined($in{'level'})) {
      &PrintError("Please select a 'Backup Level'"); exit;
    }
    elsif ($in{'name'} !~ m/^[A-Za-z0-9\ ]+$/) {
      &PrintError("You entered an invalid 'Backup Description'"); exit; 
    }
    elsif (! -d $in{'directory'}) {
      &PrintError("The 'Directory' you specified does not exist."); exit; 
    }

  ###
  ###  END Input Validation
  ###

 
  ###  Kill any traiiling slashes on directory names.
  $in{'directory'} =~ s/\/+$// if ($in{'directory'} ne "/");


  ###  Case 1:  We want to define a new named backup.
  if ($in{'create'})
  {
    local ($name)  =  &GetNextBackupName();

    my %tmp = &ListNamedBackups();
    my $cnt = 0;
    foreach my $k (sort keys %tmp) { $cnt++ if (defined($tmp{$k}->{'name'})); }
    if ($cnt >= 10) {
      my $msg = "You have reached the limit of 10 named backups available\\n"
              . "in the Community Edition of EnGarde Secure Linux.";
      &PrintError($msg);
      exit;
    }

    ###  Read the file.
    $lref = &read_file_lines("$module_config_directory/config");

    ###  Push our new lines onto the file.
    push @$lref, "$name" . "_name=$in{'name'}";
    push @$lref, "$name" . "_directory=$in{'directory'}";
    push @$lref, "$name" . "_exclude=$in{'exclude'}";
    push @$lref, "$name" . "_schedule=$in{'schedule'}";
    push @$lref, "$name" . "_level=$in{'level'}";
    push @$lref, "";

    ###  Write the file back to disk.
    &flush_file_lines();
  }

  ###  Case 2:  We want to delete or update an existing named backup.
  else
  {
    ###  Define local variables.
    my ($b, %backups, $base_line);

    ###  Setup local variables.
    $b               =  $in{'backupNum'};
    %backups         =  &ListNamedBackups();
    $base_line       =  $backups{$b}->{'lineno'};


    ###  Read the file.
    $lref = &read_file_lines("$module_config_directory/config");

      if ($in{'delete'}) { splice @$lref, $base_line - 1, 6; }
      else {
        ###  Edit the file, blindly, based upon our assumptions.
        @$lref[$base_line - 1] = "$b" . "_name=$in{'name'}";
        @$lref[$base_line]     = "$b" . "_directory=$in{'directory'}";
        @$lref[$base_line + 1] = "$b" . "_exclude=$in{'exclude'}";
        @$lref[$base_line + 2] = "$b" . "_schedule=$in{'schedule'}";
        @$lref[$base_line + 3] = "$b" . "_level=$in{'level'}";
      }

    ###  Write the file back to disk.
    &flush_file_lines();
  }

  ###  Go back to the index page.
  &redirect("edit_config.cgi");
