#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: do_restore.cgi,v 1.1.1.1 2001/12/11 06:50:39 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.  Use Time::HiRes for the timer.
  use Time::HiRes qw(usleep ualarm gettimeofday tv_interval);
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($b, $level, $date, %BACKUPS, @backups, $stored_backup);
  my ($templog, $tempinclude);
  my ($seek_cmd, $restore_cmd);
  my ($t0, $t1, $timespent);

  ###  Setup local variables.
  $templog      =  &tempname();
  $tempinclude  =  &tempname();
  $b            =  $in{'selectedBackup'};
  $level        =  $in{'level'};
  $date         =  $in{'date'};
  %BACKUPS      =  &ListNamedBackups();
  @backups      =  &ListStoredBackups($b);


  ###  Iterate through all the backups for this $b and find our target file.
  foreach my $x (@backups) {
    if ( ($x->{'level'} eq $level) && ($x->{'date'} eq $date) ) {
      $stored_backup = $x;
    }
  }


  ###  If we are restoring from tape, set up our $seek_cmd.
  if ($stored_backup->{'file'} eq "TAPE") {
    $seek_cmd     =  "mt -f /dev/nst0 seek ";
    $seek_cmd    .=  &GetStartBlock($stored_backup->{'base'},
                                    $stored_backup->{'datestamp'}, $level);
    $seek_cmd    .=  " > /dev/null 2>&1";
    $restore_cmd  =  "$FLEXBACKUP_BIN -extract ";
    $restore_cmd .=  "-files $tempinclude "
  }
  else {
    $seek_cmd     =  undef;
    $restore_cmd  =  "$FLEXBACKUP_BIN -extract $stored_backup->{'file'} ";
    $restore_cmd .=  "-files $tempinclude "
  }


  ###
  ###  Build the list of files to include in this restoration.
  ###
  my ($HAVE_INC); $HAVE_INC = 0;
  open INCLUDEFILE, ">$tempinclude";
    foreach my $k (sort keys %in) {
      if (($k =~ m/^$date\|$level\|files\|(.*)/) && ($in{$k} == 1)) {
        $HAVE_INC++;
        if ($1 eq ".") {
          print INCLUDEFILE "\*\n";
          goto CONTINUE
        }
        else { print INCLUDEFILE "$1\*\n"; }
      }
    }
CONTINUE:

    ###  The special case for when the user doesn't select a directory.
    if (! $HAVE_INC) { print INCLUDEFILE "\*\n"; }

  close INCLUDEFILE;


  ###
  ###  Change directory to the directory we want to restore.
  ###  This directory may not exist, in which case, create it.
  ###
  ###  AUD:  Set up permissions on directory somehow?
  ###
  system("mkdir -p $BACKUPS{$b}->{'directory'}") if (! -d $BACKUPS{$b}->{'directory'});
  chdir $BACKUPS{$b}->{'directory'};


  ###  We now have our command strings built up, so let's execute it.
  $restore_cmd .=  " >$templog 2>&1";
  $t0  =  [gettimeofday];
    system($seek_cmd) if ($seek_cmd);
    system($restore_cmd);
    $rc  =  $?;
  $t1  =  [gettimeofday];
  $timespent  =  tv_interval $t0, $t1;


  ###  Unlink our include file and redirect to our stats page.
  unlink $tempinclude;
  &redirect("stats_restore.cgi?selectedBackup=$b&rc=$rc&time=$timespent&level=$level&date=$date&readfile=$templog");

