#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: edit_config.cgi,v 1.2 2002/05/02 01:25:51 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "SystemBackup-lib.pl";


  ###  Define local variables.
  my (%backups);
  my ($device_HELP,   $afio_overwrite_newer_HELP,   $erase_rewind_only_HELP);
  my ($device_SELECT, $afio_overwrite_newer_SELECT, $erase_rewind_only_SELECT);

  ###  Setup local variables.
  %backups                      =  &ListNamedBackups();
  $device_HELP                  =  &hlink("Backup Method", "device");
  $afio_overwrite_newer_HELP    =  &hlink("Overwrite Newer Files?", "afio_overwrite_newer");
  $erase_rewind_only_HELP       =  &hlink("Rewind Only?", "erase_rewind_only");

  ###  Build '$device_SELECT'.
  $device_SELECT  =  "<SELECT NAME=\"device\">\n";
  foreach my $l (sort keys %BACKUP_DEVICES)
  {
    $device_SELECT .=  "  <OPTION VALUE=\"$l\" ";
    $device_SELECT .= "SELECTED" if ($device eq $l);
    $device_SELECT .=  ">" . $BACKUP_DEVICES{$l} . "</OPTION>\n";
  }
  $device_SELECT .=  "</SELECT>\n";

  ###  Build '$afio_overwrite_newser_SELECT'.
  $afio_overwrite_newer_SELECT  =  "<SELECT NAME=\"afio_overwrite_newer\">\n";
  foreach my $l (sort keys %TRUEFALSE)
  {
    $afio_overwrite_newer_SELECT .=  "  <OPTION VALUE=\"$l\" ";
    $afio_overwrite_newer_SELECT .= "SELECTED" if ($afio_overwrite_newer eq $l);
    $afio_overwrite_newer_SELECT .=  ">" . $TRUEFALSE{$l} . "</OPTION>\n";
  }
  $afio_overwrite_newer_SELECT .=  "</SELECT>\n";

  ###  Build '$erase_rewind_only_SELECT'.
  $erase_rewind_only_SELECT  =  "<SELECT NAME=\"erase_rewind_only\">\n";
  foreach my $l (sort keys %TRUEFALSE)
  {
    $erase_rewind_only_SELECT .=  "  <OPTION VALUE=\"$l\" ";
    $erase_rewind_only_SELECT .= "SELECTED" if ($erase_rewind_only eq $l);
    $erase_rewind_only_SELECT .=  ">" . $TRUEFALSE{$l} . "</OPTION>\n";
  }
  $erase_rewind_only_SELECT .=  "</SELECT>\n";


  ###  Print the usual header.
  &header("System Backup :: Configuration", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_edit_config.cgi" METHOD="POST">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below you can edit your general configuration (choose the backup method)
      and perform Named Backup operations.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">

      <TR $tb>
        <TD COLSPAN="2">
          <DIV CLASS="thead"><B>General Configuration</B></DIV>
        </TD>
      </TR>

      <TR>
        <TD WIDTH="50%"><DIV CLASS="nbody"><B>$device_HELP</B></DIV></TD>
        <TD WIDTH="50%"><DIV CLASS="nbody"> $device_SELECT </DIV></TD>
      </TR>

      <TR>
        <TD WIDTH="50%"><DIV CLASS="nbody"><B>$afio_overwrite_newer_HELP</B></DIV></TD>
        <TD WIDTH="50%"><DIV CLASS="nbody"> $afio_overwrite_newer_SELECT </DIV></TD>
      </TR>

      <TR>
        <TD WIDTH="50%"><DIV CLASS="nbody"><B>$erase_rewind_only_HELP</B></DIV></TD>
        <TD WIDTH="50%"><DIV CLASS="nbody"> $erase_rewind_only_SELECT </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="nbody">
          <INPUT TYPE="SUBMIT" VALUE="Save Configuration">
        </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>


      <TR $tb>
        <TD COLSPAN="2">
          <DIV CLASS="thead"><B>Defined Named Backups</B></DIV>
        </TD>
      </TR>

      <TR $cb>
        <TD COLSPAN="2"> <DIV CLASS="nbody">
          A <B>Named Backup</B> is a directory you wish to perform backups on.
          In order to back up a directory it must have a named backup defined.
          Below you can define a new named backup, or edit/delete an existing
          one.
        </DIV> </TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD COLSPAN="2">
        <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
        <TR $cb>
          <TD WIDTH="10"> &nbsp; </TD>
          <TD $tb><DIV CLASS="thead"><B>Backup Label</B></DIV></TD>
          <TD $tb><DIV CLASS="thead"><B>Schedule</B></DIV></TD>
          <TD $tb>&nbsp;</TD>
        </TR>
EOF


  ###  We break for a word from our sponsors.
  foreach my $b (sort keys %backups)
  {
    my ($schedule);

    ###  Don't display the level if it's not scheduled.
    if ($backups{$b}->{'schedule'} eq "NEVER") {
      $schedule = $BACKUP_TIMES{$backups{$b}->{'schedule'}};
    }
    else {
      $schedule = "$BACKUP_TIMES{$backups{$b}->{'schedule'}} ($BACKUP_TYPES_SHORT{$backups{$b}->{'level'}})";
    }

    ###  Print some HTML.
    print <<EOF;
        <TR $cb>
          <TD WIDTH="10"> &nbsp; </TD>
          <TD><DIV CLASS="nbody"> $backups{$b}->{'name'} </DIV></TD>
          <TD><DIV CLASS="nbody"> $schedule </DIV></TD>
          <TD><DIV CLASS="nbody"> <A HREF="edit_named_backup.cgi?b=$b"><B>[&nbsp;Edit&nbsp;]</B></A></DIV></TD>
        </TR>
EOF
  }


  ###  And now back to our regularly scheduled programming.
  print <<EOF;
        </TABLE>
        </TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="nbody"><B>
          <A HREF="edit_named_backup.cgi?create=1">[ Define New Named Backup ]</A>
        </B></DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      </TABLE>
    </TD>
  </TR>

  </TABLE>
  </FORM>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("index.cgi");

