#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: edit_named_backup.cgi,v 1.2 2002/05/02 01:25:51 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($b, %backups, $new, $device_HELP, $device_SELECT);
  my ($fcn_TEXT, $fcn_DESC, $hidden_TEXT, $submit_TEXT);

  ###  Setup local variables.
  $b               =  $in{'b'};
  $new             =  $in{'create'};
  %backups         =  &ListNamedBackups();
  $name_HELP       =  &hlink("Backup Description", "named_backup_name");
  $directory_HELP  =  &hlink("Directory",          "named_backup_directory");
  $exclude_HELP    =  &hlink("Exclude Patterns",   "named_backup_exclude");
  $schedule_HELP   =  &hlink("Backup Schedule",    "named_backup_schedule");
  $level_HELP      =  &hlink("Backup Level",       "named_backup_level");


  ###  Setup some display variables for new/edit.
  if ($new) {
    $fcn_TEXT     =  "Define";
    $fcn_DESC     =  "Below you can define a new named backup.";

    $submit_TEXT  =  "      <TR>\n";
    $submit_TEXT .=  "        <TD COLSPAN=\"2\" ALIGN=\"RIGHT\"><DIV CLASS=\"nbody\">\n";
    $submit_TEXT .=  "          <INPUT TYPE=\"SUBMIT\" NAME=\"create\" VALUE=\"Define Named Backup\">\n";
    $submit_TEXT .=  "        </DIV></TD>\n";
    $submit_TEXT .=  "      </TR>\n";
  }
  else {
    $fcn_TEXT     =  "Edit";
    $fcn_DESC     =  "Below you can edit or delete an existing named backup.";

    $hidden_TEXT  =  "<INPUT TYPE=\"HIDDEN\" NAME=\"backupNum\" VALUE=\"$b\">";

    $submit_TEXT  =  "      <TR>\n";
    $submit_TEXT .=  "        <TD ALIGN=\"LEFT\"><DIV CLASS=\"nbody\">\n";
    $submit_TEXT .=  "          <INPUT TYPE=\"SUBMIT\" NAME=\"delete\" VALUE=\"Delete Named Backup\">\n";
    $submit_TEXT .=  "        </DIV></TD>\n";
    $submit_TEXT .=  "        <TD ALIGN=\"RIGHT\"><DIV CLASS=\"nbody\">\n";
    $submit_TEXT .=  "          <INPUT TYPE=\"SUBMIT\" NAME=\"update\" VALUE=\"Update Named Backup\">\n";
    $submit_TEXT .=  "        </DIV></TD>\n";
    $submit_TEXT .=  "      </TR>\n";
  }


  ###  Print the usual header.
  &header("System Backup :: $fcn_TEXT Named Backup", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_edit_named_backup.cgi" METHOD="POST">
  $hidden_TEXT
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below you can perform named backup operations.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">

      <TR $tb>
        <TD COLSPAN="2">
          <DIV CLASS="thead"><B>$fcn_TEXT a Named Backup</B></DIV>
        </TD>
      </TR>

      <TR $cb>
        <TD COLSPAN="2"> <DIV CLASS="nbody">
          $fcn_DESC
        </DIV> </TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>$name_HELP</B></DIV></TD>
        <TD>
          <INPUT TYPE="TEXT" NAME="name" SIZE="30" VALUE="$backups{$b}->{'name'}">
        </TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>$directory_HELP</B></DIV></TD>
        <TD>
          <INPUT TYPE="TEXT" NAME="directory" SIZE="30" VALUE="$backups{$b}->{'directory'}">
        </TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>$exclude_HELP</B></DIV></TD>
        <TD>
          <INPUT TYPE="TEXT" NAME="exclude" SIZE="30" VALUE="$backups{$b}->{'exclude'}">
        </TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>$schedule_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">
          <SELECT NAME="schedule">
EOF


  ###  Display all the backup times.
  foreach my $t ('NEVER', 'daily', 'weekly', 'monthly')
  {
    print "            <OPTION VALUE=\"$t\" ";
    print "SELECTED" if ($backups{$b}->{'schedule'} eq $t);
    print ">$BACKUP_TIMES{$t}</OPTION>\n";
  }


  ###  More HTML.
  print <<EOF;
          </SELECT>
        </DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>$level_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">
          <SELECT NAME="level">
EOF


  ###  Display all the backup times.
  foreach my $l ('0', '9')
  {
    print "            <OPTION VALUE=\"$l\" ";
    print "SELECTED" if ($backups{$b}->{'level'} eq $l);
    print ">$BACKUP_TYPES{$l}</OPTION>\n";
  }


  ###  More HTML.
  print <<EOF;
          </SELECT>
        </DIV></TD>
      </TR>


      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      </TABLE>
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2">
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
$submit_TEXT
      </TABLE>
    </TD>
  </TR>

  </TABLE>
  </FORM>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("edit_config.cgi");

