#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: index.cgi,v 1.2 2002/05/02 01:25:51 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "SystemBackup-lib.pl";


  ###  Define local variables.
  my ($maint_LINK, $maint_TEXT, $main_DESC);

  ###  Setup local variables.
  if ($device eq "/var/BACKUP") {
    $maint_LINK  =  "directory_maintenance.cgi";
    $maint_TEXT  =  "Perform Directory Maintenance";
    $maint_DESC  =  "Initialize the system backup software.";
  }
  else {
    $maint_LINK  =  "tape_maintenance.cgi";
    $maint_TEXT  =  "Perform Tape Maintenance";
    $maint_DESC  =  "Initialize a tape and the system backup software.";
  }


  ###  Print the usual header.
  &header("System Backup", 0);


  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Welcome to the System Backup module.  Below you can define Named Backups,
      execute backups and restore backups.  Click on the help link below for
      general help on this module.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR>
        <TD><DIV CLASS="nbody"><B>
          <A HREF="edit_config.cgi"> System Backup Configuration </A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody">
          Define the backup method and configure named backups.
        </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>
          <A HREF="$maint_LINK"> $maint_TEXT </A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody"> $maint_DESC </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>
          <A HREF="select_named_backup.cgi?action=create"> Create a New Backup </A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody"> Execute a backup immediately. </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>
          <A HREF="select_named_backup.cgi?action=restore"> Restore a Backup </A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody"> Select a backup to restore. </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>
          <A HREF="select_named_backup.cgi?action=diff"> View Changes Since Backup </A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody"> See what files have been removed and altered. </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>


      <TR>
        <TD><DIV CLASS="nbody"><B>
          <A onClick='window.open("SystemBackup_help.cgi", "help", "toolbar=no,menubar=no,scrollbars=yes,width=400,height=450,resizable=yes"); return false' HREF="SystemBackup_help.cgi">[ System Backup Help ]</A>
        </B></DIV></TD>
        <TD><DIV CLASS="nbody">
          View the help page for this module.
        </DIV></TD>
      </TR>

      <TR> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      </TABLE>
    </TD>
  </TR>

  </TABLE>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("/");

