#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: restore_select_date.cgi,v 1.2 2002/05/02 01:25:51 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($b, %backups, $HAVE_BACKUPS);

  ###  Setup local variables.
  $b             =  $in{'selectedBackup'};
  %backups       =  &ListNamedBackups();
  $HAVE_BACKUPS  =  0;


  ###  Throw an error if we are not given a backup.
  if (!$b) {
    &PrintError("Please select a named backup");
    exit;
  }


  ###  Print the usual header.
  &header("System Backup :: Select Restore Date", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="verify_restore.cgi" METHOD="POST">
  <INPUT TYPE="HIDDEN" NAME="selectedBackup" VALUE="$b">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below is a listing of the currently available backups for
      <B>$backups{$b}->{'name'}</B>.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD WIDTH="1%"> &nbsp; </TD>
        <TD><DIV CLASS="thead"><B>Backup Name</B></DIV></TD>
        <TD><DIV CLASS="thead"><B>Backup Date</B></DIV></TD>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Backup Type</B></DIV></TD>
      </TR>
EOF

  ###  Iterate through all the backups, displaying level and date.
  foreach my $x (&ListStoredBackups($b)) {
    $HAVE_BACKUPS  =  1;

    my ($BASE, $LOGFILE, $i, $LINK);
    $i        =  0;
    $BASE     =  $backups{$b}->{'directory'};
    $BASE     =~ s/\//\-/g;
    $BASE     =~ s/^\-//;
    $LOGFILE  =  "$FLEXBACKUP_LOGDIR/$BASE.$x->{'level'}.$x->{'logstamp'}.gz";

    if ($in{'LOG'} eq $LOGFILE) {
      $LINK     = "restore_select_date.cgi?selectedBackup=$b";
    }
    else {
      $LINK     = "restore_select_date.cgi?selectedBackup=$b&LOG=$LOGFILE";
    }

    ###  Print leading information (name, date, level, expand link).
    print <<EOF;
      <TR $cb>
        <TD><INPUT TYPE="RADIO" NAME="restoreInfo" VALUE="$x->{'date'}|$x->{'level'}"></TD>
        <TD><DIV CLASS="nbody">$backups{$b}->{'name'}</DIV></TD>
        <TD><DIV CLASS="nbody">$x->{'date'}</DIV></TD>
        <TD><DIV CLASS="nbody">$BACKUP_TYPES{$x->{'level'}}</DIV></TD>
        <TD><DIV CLASS="nbody"><B>
<A HREF="$LINK">[&nbsp;Toggle&nbsp;List&nbsp;]</A>
        </B></DIV></TD>
      </TR>
EOF

    ###  If this is expanded, list the directories.
    if ((-f "$LOGFILE") && ($in{'LOG'} eq $LOGFILE)) {
      open LOG, "gzip -dc $LOGFILE |";
        while (my $line = <LOG>) {
          chomp $line;

          if ($line =~ m/^(.+)\ \-\-\ .*\(directory\)$/) {
            $i++;
            $dir =  $1;
            $dir = "<B>Entire Archive</B>" if ($1 eq ".");

            print <<EOF;
      <TR $cb>
        <TD> &nbsp;</TD>
        <TD COLSPAN="4"><DIV CLASS="nbody">
          <INPUT TYPE="CHECKBOX" NAME="$x->{'date'}|$x->{'level'}|files|$1" VALUE="1"> &nbsp;&nbsp; $dir
        </DIV></TD>
      </TR>
EOF
          }
        }
      close LOG
    }
  }

  ###  We don't have any backups, so print something.
  if (!$HAVE_BACKUPS) {
    print <<EOF;
      <TR $cb>
        <TD COLSPAN="5"><DIV CLASS="nbody">
          <B>There are currently no backups to restore</B>
        </DIV></TD>
      </TR>
EOF
  }

  ###  More HTML.
  print <<EOF;
        </DIV></TD>
      </TR>

      </TABLE>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

EOF


  ###  Print the pretty button (bewm).
  if ($HAVE_BACKUPS) {
    print <<EOF;
  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="nbody">
      <INPUT TYPE="SUBMIT" VALUE="Restore Backup">
    </DIV></TD>
  </TR>
EOF
  }


  ###  More HTML.
  print <<EOF;
  </TABLE>
  </FORM>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("select_named_backup.cgi?action=restore");

