#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: select_named_backup.cgi,v 1.2 2002/05/02 01:25:51 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($action, %backups, $select_TEXT, $select_FORM);

  ###  Setup local variables.
  $action   =  $in{'action'};
  %backups  =  &ListNamedBackups();


  ###  Setup our description and FORM.  Go to index.cgi if action is invalid.
  if ($action eq "create") {
    $select_TEXT  =  "Below you can select which backup you wish to create.";
    $select_FORM  =  "verify_create.cgi";
  }
  elsif ($action eq "restore") {
    $select_TEXT  =  "Below you can select which backup you wish to restore.";
    $select_FORM  =  "restore_select_date.cgi";
  }
  elsif ($action eq "delete") {
    $select_TEXT  =  "Below you can select which backup you wish to delete.";
    $select_FORM  =  "delete_select_date.cgi";
  }
  elsif ($action eq "diff") {
    $select_TEXT  =  "Below you can select which backup you wish to query.";
    $select_FORM  =  "diff_select_date.cgi";
  }
  else { &redirect("index.cgi"); }


  ###  Print the usual header.
  &header("System Backup :: Select Named Backup", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="$select_FORM" METHOD="POST">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      $select_TEXT
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">

      <TR $tb>
        <TD WIDTH="1%"> &nbsp; </TD>
        <TD WIDTH="50%"><DIV CLASS="thead"><B>Backup Name</B></DIV></TD>
        <TD WIDTH="49%"><DIV CLASS="thead"><B>Directory</B></DIV></TD>
      </TR>

EOF


  ###  Iterate through each backup, displaying the name and directory.
  foreach my $b (sort keys %backups)
  {
    print <<EOF;
      <TR $cb>
        <TD><INPUT TYPE="RADIO" NAME="selectedBackup" VALUE="$b"></TD>
        <TD><DIV CLASS="nbody"><B>$backups{$b}->{'name'}</B></DIV></TD>
        <TD><DIV CLASS="nbody">$backups{$b}->{'directory'}</DIV></TD>
      </TR>

EOF
  }


  ###  More HTML.
  print <<EOF;
      </TABLE>
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="nbody">
      <INPUT TYPE="SUBMIT" VALUE="Select">
    </DIV></TD>
  </TR>

  </TABLE>
  </FORM>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("index.cgi");

