#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: stats_create.cgi,v 1.2 2002/05/02 01:25:51 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($b, $rc, $time, $level, %backups, $logfile);
  my (@written_files, $kilobytes_written);

  ###  Setup local variables.
  $b            =  $in{'selectedBackup'};
  $rc           =  $in{'rc'};
  $level        =  $in{'level'};
  $time         =  int($in{'time'});
  %backups      =  &ListNamedBackups();

  $logfile      =  $backups{$b}->{'directory'};
  $logfile      =~ s/\//\-/g;
  $logfile      =~ s/^\-//;
  $logfile     .=  ".latest.gz";


  ###  Read the compressed log file and populate our variables.
  open LOG, "gzip -dc $FLEXBACKUP_LOGDIR/$logfile |";
    while (my $line = <LOG>)
    {
      chomp $line;

      next if ($line =~ m/^\|/);

      ###  We have a file that was backed up.
      if (($line =~ m/^[0-9]+\ (.*)\ \-\-\ [o\(]/) ||
          ($line =~ m/^(.*)\ \-\-\ [o\(]/)) {
        if ( ($1 ne ".") && ($1 !~ m/^CONTROL\_FILE/) ) {
          push @written_files, $1;
        }
      }

      ###  We have the number of k out.
      elsif ($line =~ m/^Kilobytes\ Out\ (.*)$/) {
        $kilobytes_written  =  $1;
      } 
    }
  close LOG;


  ###  Print the standard header.
  &header("System Backup :: Backup Creation Statistics", 0);

  ###  Now print the HTML.
  print <<EOF;
<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Your backup of <B>$backups{$b}->{'name'}</B> was successful.  The backup
      took <B>$time seconds</B>.  The total backup size was
      <B>$kilobytes_written k</B>.

    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">

      <TR $tb>
        <TD> <DIV CLASS="thead"><B>Files Backed Up</B></DIV> </TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody">
           Below is a complete list of the files that were included in this
           backup.  Files ending in a '.z' were compressed.
        </DIV></TD>
      </TR>

      <TR $cb> <TD> &nbsp; </TD> </TR>

      <TR $cb>
        <TD><PRE>
EOF


  ###  Print the filenames.  Print _something_ if no files changed. (bewm)
  if (@written_files > 0) {
    for (my $i = 0; $i <= @written_files; $i++) {
      print "   $written_files[$i]\n";
    }
  }
  else { print "<B>No files to be backed up.</B>\n"; }


  ###  More HTML.
  print <<EOF;
        </PRE></TD>
      </TR>

      <TR $cb> <TD> &nbsp; </TD> </TR>

      <TR $cb>
        <TD ALIGN="RIGHT"><DIV CLASS="nbody"><B>
          <A HREF="index.cgi">[&nbsp;Return&nbsp;To&nbsp;Index&nbsp;Page&nbsp;]</A>
        </B></DIV></TD>
      </TR>

      <TR $cb> <TD> &nbsp; </TD> </TR>
      </TABLE>
    </TD>
  </TR>
  </TABLE>
</CENTER></P>
EOF


  ###  Print the standard footer.
  &ryanFooter("select_named_backup.cgi?action=create");

