#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: stats_diff.cgi,v 1.2 2002/05/02 01:25:51 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($b, $rc, $time, $level, %backups, $logfile);
  my (@written_files, $kilobytes_written);

  ###  Setup local variables.
  $b            =  $in{'selectedBackup'};
  $rc           =  $in{'rc'};
  $level        =  $in{'level'};
  $time         =  int($in{'time'});
  %backups      =  &ListNamedBackups();


  ###  Print the standard header.
  &header("System Backup :: Backup Comparison", 0);

  ###  Now print the HTML.
  print <<EOF;
<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below is a listing of files that have changed.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">

      <TR $tb>
        <TD> <DIV CLASS="thead"><B>Changed Files</B></DIV> </TD>
      </TR>

      <TR $cb> <TD> &nbsp; </TD> </TR>

      <TR $cb>
        <TD><PRE>
EOF

  ###  Open our temp. log file and show all the "changed" files.
  my ($COUNT); $COUNT = 0;
  open LOG, $in{'readfile'};
    while (my $line = <LOG>)
    {
      chomp $line;

      if ($line =~ m/^afio\:\ \"([^\"]+)\"\:\ +(.*)$/) {
        if ($2 eq "No such file or directory") {
          print "Removed:  $1\n"; $COUNT++;
        }
        elsif ($2 eq "Corrupt archive data")   {
          print "Modified:  $1\n"; $COUNT++;
        }
      }
    }
  close LOG;

  ###  Now unlink the temp. file.
  unlink $in{'readfile'};


  ###  Print _something_ if no files changed. (bewm)
  if (! $COUNT) { print "<B>No files have changed.</B>\n"; }

  ###  More HTML.
  print <<EOF;
        </PRE></TD>
      </TR>

      <TR $cb> <TD> &nbsp; </TD> </TR>

      <TR $cb>
        <TD ALIGN="RIGHT"><DIV CLASS="nbody"><B>
          <A HREF="index.cgi">[&nbsp;Return&nbsp;To&nbsp;Index&nbsp;Page&nbsp;]</A>
        </B></DIV></TD>
      </TR>

      <TR $cb> <TD> &nbsp; </TD> </TR>
      </TABLE>
    </TD>
  </TR>
  </TABLE>
</CENTER></P>
EOF


  ###  Print the standard footer.
  &ryanFooter("select_named_backup.cgi?action=diff");

