#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: stats_restore.cgi,v 1.2 2002/05/02 01:25:51 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($b, $rc, $time, $level, %backups, $logfile);
  my (@written_files, $kilobytes_written);

  ###  Setup local variables.
  $b            =  $in{'selectedBackup'};
  $rc           =  $in{'rc'};
  $level        =  $in{'level'};
  $time         =  int($in{'time'});
  %backups      =  &ListNamedBackups();


  ###  Print the standard header.
  &header("System Backup :: Backup Restoration Statistics", 0);

  ###  Now print the HTML.
  print <<EOF;
<P><CENTER>
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Your restoration of <B>$backups{$b}->{'name'}</B> was successful.  The
      restoration took <B>$time seconds</B>.  The total restoration size was
      <B>$kilobytes_written k</B>.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">

      <TR $tb>
        <TD> <DIV CLASS="thead"><B>Files Restored</B></DIV> </TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody">
           Below is a complete list of the files that were included in this
           restoration.
        </DIV></TD>
      </TR>

      <TR $cb> <TD> &nbsp; </TD> </TR>

      <TR $cb>
        <TD><PRE>
EOF


  ###  Open our temp. log file and show all the "changed" files.
  my ($COUNT, $PRINT); $COUNT = 0; $PRINT = 0;
  open LOG, $in{'readfile'};
    while (my $line = <LOG>)
    {
      chomp $line;

      $PRINT = 0 if ($line =~ m/^\|/);
        if ($PRINT && $line =~ m/^[0-9]+\s+(.+)\ \-\-\ /)    {
          print "$1\n"; $COUNT++;
        }
        elsif ($PRINT && $line =~ m/^(.+)\ \-\-\ /) {
          print "$1\n"; $COUNT++;
        }
      $PRINT = 1 if ($line =~ m/CONTROL\_FILE/);
    }
  close LOG;

  ###  Now unlink the temp. file.
  unlink $in{'readfile'};

  ###  Print _something_ if no files changed. (bewm)
  if (! $COUNT) { print "<B>No files needed to be restored.</B>\n"; }


  ###  More HTML.
  print <<EOF;
        </PRE></TD>
      </TR>

      <TR $cb> <TD> &nbsp; </TD> </TR>

      <TR $cb>
        <TD ALIGN="RIGHT"><DIV CLASS="nbody"><B>
          <A HREF="index.cgi">[&nbsp;Return&nbsp;To&nbsp;Index&nbsp;Page&nbsp;]</A>
        </B></DIV></TD>
      </TR>

      <TR $cb> <TD> &nbsp; </TD> </TR>
      </TABLE>
    </TD>
  </TR>
  </TABLE>
</CENTER></P>
EOF


  ###  Print the standard footer.
  &ryanFooter("select_named_backup.cgi?action=restore");

