#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: verify_create.cgi,v 1.2 2002/05/02 01:25:51 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($b, %backups);

  ###  Setup local variables.
  $b        =  $in{'selectedBackup'};
  %backups  =  &ListNamedBackups();


  ###  Throw an error if we are not given a backup.
  if (!$b) {
    &PrintError("Please select a named backup");
    exit;
  }

  ###  Throw an error if our target directory does not exist.
  if (! -d $backups{$b}->{'directory'}) {
    &PrintError("Unable to backup '$backups{$b}->{'directory'} because it does not exist.");
    exit;
  }

  ###  Print the usual header.
  &header("System Backup :: Verify Backup Creation", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_create.cgi" METHOD="POST">
  <INPUT TYPE="HIDDEN" NAME="selectedBackup" VALUE="$b">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below is an overview of what will be backed up and how it will be backed
      up.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="300">

      <TR>
        <TD><DIV CLASS="nbody"><B>Backup Method</B></DIV></TD>
        <TD><DIV CLASS="nbody">$BACKUP_DEVICES{$device}</DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>Name of Backup</B></DIV></TD>
        <TD><DIV CLASS="nbody">$backups{$b}->{'name'}</DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>Directory Back Up</B></DIV></TD>
        <TD><DIV CLASS="nbody">
          $backups{$b}->{'directory'}
EOF


  ###  Print the "Exclude:" thingie if we want to exclude anything.
  if ($backups{$b}->{'exclude'}) {
    print "(Exclude:  $backups{$b}->{'exclude'})\n";
  }


  ###  More HTML.
  print <<EOF;
        </DIV></TD>
      </TR>

      </TABLE>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Click the <B>Create Incremental Backup</B> button if you wish to continue
      with an incremental backup.

      <P>Click the <B>Create Full Backup</B> button if you wish to continue
      with a full backup.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="nbody">
      <INPUT TYPE="SUBMIT" NAME="incremental" VALUE="Create Incremental Backup">
      <INPUT TYPE="SUBMIT" NAME="full" VALUE="Create Full Backup">
    </DIV></TD>
  </TR>

  </TABLE>
  </FORM>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("select_named_backup.cgi?action=create");

