#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: verify_restore.cgi,v 1.2 2002/05/02 01:25:51 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "SystemBackup-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($b, $date, $level, %backups);

  ###  Setup local variables.
  $b               =  $in{'selectedBackup'};
  ($date, $level)  =  split /\|/, $in{'restoreInfo'};
  %backups         =  &ListNamedBackups();


  ###  Throw an error if we are not given a backup.
  if (!$date) {
    &PrintError("Please select a date to restore.");
    exit;
  }


  ###  Print the usual header.
  &header("System Backup :: Verify Backup Restoration", 0);

  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_restore.cgi" METHOD="POST">
  <INPUT TYPE="HIDDEN" NAME="selectedBackup" VALUE="$b">
  <INPUT TYPE="HIDDEN" NAME="date" VALUE="$date">
  <INPUT TYPE="HIDDEN" NAME="level" VALUE="$level">
EOF


  ###  Print each file as a HIDDEN element.
  foreach my $k (sort keys %in) {
    if (($k =~ m/^$date\|$level\|files/) && ($in{$k} == 1)) {
      print "  <INPUT TYPE=\"HIDDEN\" NAME=\"$k\" VALUE=\"1\">\n";
    }
  }


  ###  More HTML.
  print <<EOF;
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below is an overviwe of what will be restored.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="300">

      <TR>
        <TD><DIV CLASS="nbody"><B>Backup to Restore</B></DIV></TD>
        <TD><DIV CLASS="nbody">$backups{$b}->{'name'}</DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>Restoration Method</B></DIV></TD>
        <TD><DIV CLASS="nbody">$BACKUP_DEVICES{$device}</DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>Restoration Level</B></DIV></TD>
        <TD><DIV CLASS="nbody">$BACKUP_TYPES{$level}</DIV></TD>
      </TR>

      <TR>
        <TD><DIV CLASS="nbody"><B>Restoration Date</B></DIV></TD>
        <TD><DIV CLASS="nbody">$date</DIV></TD>
      </TR>

      </TABLE>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="nbody">
      <INPUT TYPE="SUBMIT" VALUE="Really Restore">
    </DIV></TD>
  </TR>

  </TABLE>
  </FORM>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("select_named_backup.cgi?action=restore");

